// @ myth - client - dungeon.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef DUNGEON_HEADER
#define DUNGEON_HEADER

// @@ include

#include "client/window.h"
#include "common/map.h"
#include "common/string.h"

// @@ type

// @@@ class DUNGEON

class DUNGEON : WINDOW
{
    MAP map;
    coor corner;
    coor position;
    bool* touched;
public:
    void clear();
    void load(BINARY* binary);
    inline void home(coor pos)
    { position = pos; }
    void plot(coor pos, char c);
    void print(coor pos, STRING string);
    void effect(coor pos, char c);
    void update();
    void flush(coor pos);
    void center(coor pos);
    inline void redraw()
    { WINDOW::redraw(); }
    DUNGEON();
    ~DUNGEON();
};

// @@ end

#endif DUNGEON_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
