// @ myth - client - global.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef GLOBAL_HEADER
#define GLOBAL_HEADER

// @@ include

#include "common/string.h"

// @@ GLOBAL

class GLOBAL
{
    STRING MyName;
    STRING MyHost;
    bool sticky_menues;
    int border_width;
    void usage();
    STRING LibraryFile(const char* name);
public:
    // Filenames 
    //
    STRING HostFile();
    STRING ServerFile();
    STRING ErrorFile();
    //
    // Options
    //
    err parse(const char* string);
    STRING name();
    STRING host();
    int border();
    bool sticky();
    //
    // Administration
    //
    void load(int argc, char** argv);
    GLOBAL();
};

extern GLOBAL global;

// @@ end

#endif GLOBAL_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
