// @ myth - server - food.h
//
// Myth is a multiuser screen oriented adventure game.
// Copyright (C) 1989 Per Abrahamsen
// 
// This file is part of Myth.
// 
// Myth is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 1, or (at your option) any later
// version.
// 
// Myth is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Myth; see the file COPYING.  If not, write to the Free
// Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
// My email address is: amanda@iesd.auc.dk

// @@ begin

#ifndef FOOD_HEADER
#define FOOD_HEADER

// @@ include

#include "server/thing.h"

// @@ RATION

class RATION : public FOOD
{
    // Identification
    //
protected:
    int FoodValue()
    { return 30 * 60; }
public:
    object_type type()
    { return FOOD_RATION; }
    const char* name()
    { return "food ration"; }
    long size()
    { return 75L * MyCount; }
    long weight()
    { return 75L * MyCount; }
    //
    // Administration
    //
private:
    void create()
    { SetLetter('r'); }
public:
    OBJECT* split(long arg)
    { MyCount -= arg; return new RATION(this, arg); }
    RATION(BINARY* binary) : (binary)
    { create(); }
    RATION(PARSE* parse) : (parse)
    { create(); }
    RATION(RATION* thing, long count) : (thing, count)
    { create(); }
    RATION(long count = 1L) : (count)
    { create(); }
};

// @@ FRUIT

class FRUIT : public FOOD
{
    // Identification
    //
protected:
    int FoodValue()
    { return 10 * 60; }
public:
    object_type type()
    { return FOOD_FRUIT; }
    const char* name()
    { return "fruit"; }
    long size()
    { return 15L * MyCount; }
    long weight()
    { return 25L * MyCount; }
    //
    // Administration
    //
private:
    void create()
    { SetLetter('f'); }
public:
    OBJECT* split(long arg)
    { MyCount -= arg; return new FRUIT(this, arg); }
    FRUIT(BINARY* binary) : (binary)
    { create(); }
    FRUIT(PARSE* parse) : (parse)
    { create(); }
    FRUIT(FRUIT* thing, long count) : (thing, count)
    { create(); }
    FRUIT(long count = 1L) : (count)
    { create(); }
};

// @@ end

#endif FOOD_HEADER

// @@ emacs
//
// Local Variables:
// mode: c++
// outline-regexp: "// @+ "
// eval: (outline-minor-mode 1)
// End:
